Codeforces Round #482 (Div. 2)

A. Pizza, Pizza, Pizza!!!

注意:long long

B. Treasure Hunt

注意:第五个样例(aaaaa,n==1)的情况要先处理一下。

感受:还是读题的问题,and the ribbon abcdabc has the beauty of 2 because its subribbon abc appears twice.(误导信息一),题目没要求是最大的连续子串。还有就是只能修改一个位置,记得给的单词是segment(一段同颜色的),后来题面好像改了。

#pragma warning(disable:4996)
#include<cmath>
#include<string>
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
#define mem(arr,in) memset(arr,in,sizeof(arr))
using namespace std;

const int maxn = 100005;

int n;

void change(string s, string& ss) {
    ss += s[0];
    for (int i = 1; i < s.size(); i++) {
        if (s[i] == s[i - 1]) continue;
        else ss += s[i];
    }
}

int getmax(string s) {
    int p[30], q[30];
    mem(p, 0);
    mem(q, 0);

    for (int i = 0; i < s.size(); i++) {
        if (s[i] >= ‘a‘ && s[i] <= ‘z‘) p[s[i] - ‘a‘]++;
        else q[s[i] - ‘A‘]++;
    }

    int res = 0;
    for (int i = 0; i < 26; i++) {
        res = max(res, p[i]);
        res = max(res, q[i]);
    }
    return res;
}

int main()
{
    while (cin >> n) {
        string a, b, c;
        cin >> a >> b >> c;

        int p[3];
        p[0] = a.size() - getmax(a);
        p[1] = b.size() - getmax(b);
        p[2] = c.size() - getmax(c);

        int x, y, z;
        int m = a.size();
     //n==1的情况有点特殊
        if (p[0] == 0) {
            if (n == 1) x = a.size() - 1;
            else x = a.size();
        }
        else x = min(m, getmax(a) + n);

        if (p[1] == 0) {
            if (n == 1) y = b.size() - 1;
            else y = b.size();
        }
        else y = min(m, getmax(b) + n);

        if (p[2] == 0) {
            if (n == 1) z = c.size() - 1;
            else z = c.size();
        }
        else z = min(m, getmax(c) + n);

        int cnt = 0, d = max(x, max(y, z));
        if (x == d) cnt++;
        if (y == d) cnt++;
        if (z == d) cnt++;

        if (cnt > 1) {
            cout << "Draw" << endl;
        }
        else {
            if (x==d) {
                cout << "Kuro" << endl;
            }
            else if (y==d) {
                cout << "Shiro" << endl;
            }
            else cout << "Katie" << endl;
        }

        /*  //修改连续同颜色的一段!!!
        string sa, sb, sc;
        change(a, sa);
        change(b, sb);
        change(c, sc);

        int p[3];
        p[0] = sa.size() - getmax(sa);
        p[1] = sb.size() - getmax(sb);
        p[2] = sc.size() - getmax(sc);

        int cnt = 0, res = maxn;
        for (int i = 0; i < 3; i++) {
            if (n >= p[i]) cnt++;
            res = min(res, p[i]);
        }

        if (cnt > 1) {
            cout << "Draw" << endl;
        }
        else {
            if (res == p[0]) {
                cout << "Kuro" << endl;
            }
            else if (res == p[1]) {
                cout << "Shiro" << endl;
            }
            else cout << "Katie" << endl;
        }
        */
    }
    return 0;
}

C. Kuro and Walking Route

题解:计数问题,两次DFS即可。

注意:可能爆int。

#pragma warning(disable:4996)
#include<map>
#include<vector>
#include<cmath>
#include<string>
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
#define ll long long
using namespace std;

const int maxn = 300005;

vector<int> G[maxn];

int n, x, y;
int dp[maxn];
bool use[maxn];

void DFS(int u) {
    use[u] = 1;
    dp[u] = 1;
    for (int i = 0; i < G[u].size(); i++) {
        int v = G[u][i];
        if (!use[v]) {
            DFS(v);
            dp[u] += dp[v];
        }
    }
}

int main()
{
    while (scanf("%d%d%d", &n, &x, &y) != EOF) {

        for (int i = 1; i <= n; i++) G[i].clear();
        for (int i = 2; i <= n; i++) {
            int u, v;
            scanf("%d%d", &u, &v);
            G[u].push_back(v);
            G[v].push_back(u);
        }

        memset(use, 0, sizeof(use));
        memset(dp, 0, sizeof(dp));

        DFS(x);
        int ans1 = dp[y];

        memset(use, 0, sizeof(use));
        memset(dp, 0, sizeof(dp));

        DFS(y);
        int ans2 = dp[x];

        ll p = (ll)n * (ll)(n - 1);
        ll q = (ll)ans2 *(ll) ans1;

        cout << p - q << endl;
    }
    return 0;
}

原文地址:https://www.cnblogs.com/zgglj-com/p/9040371.html

时间: 2024-10-17 03:23:44

Codeforces Round #482 (Div. 2)的相关文章

Codeforces Round #482 (Div. 2) :B - Treasure Hunt

题目链接:http://codeforces.com/contest/979/problem/B 解题心得: 这个题题意就是三个人玩游戏,每个人都有一个相同长度的字符串,一共有n轮游戏,每一轮三个人必须改变自己字符串中的一个字母,最后得分就是字符串中出现字符最多的字母的次数. 感觉这个题从题目描述到做法都像一个脑筋急转弯.主要明白一点,如果一个数要变回自己要怎么变.自己->其他->自己.自己->其他->其他->自己,推几个特例很容易就出来了. 1 #include <b

Codeforces Round #482 (Div. 2)D. Kuro and GCD and XOR and SUM+字典树

题目链接:D. Kuro and GCD and XOR and SUM 题意:两种操作:第一种给数组添加一个数,第二种输入x,k,s,要求从数组中找到一个数v,要求k能整除gcd(k,v);并且v<=s-x,然后异或v与k的异或值最大. 题解:对与k大于1的情况我们暴力枚举过去,k为1的特殊处理建一颗字典树,如果可以的满足条件的话,每次取值时往相反方向取. 1 #include<bits/stdc++.h> 2 #include <iostream> 3 #include

Codeforces Round #275 (Div. 1)A. Diverse Permutation 构造

Codeforces Round #275 (Div. 1)A. Diverse Permutation Time Limit: 1 Sec  Memory Limit: 256 MB 题目连接 http://codeforces.com/contest/482/problem/A Description Permutation p is an ordered set of integers p1,   p2,   ...,   pn, consisting of n distinct posi

Codeforces Round #428 (Div. 2)

Codeforces Round #428 (Div. 2) A    看懂题目意思就知道做了 #include<bits/stdc++.h> using namespace std; #pragma comment(linker, "/STACK:102400000,102400000") #define rep(i,a,b) for (int i=a; i<=b; ++i) #define per(i,b,a) for (int i=b; i>=a; --i

Codeforces Round #424 (Div. 2) D. Office Keys(dp)

题目链接:Codeforces Round #424 (Div. 2) D. Office Keys 题意: 在一条轴上有n个人,和m个钥匙,门在s位置. 现在每个人走单位距离需要单位时间. 每个钥匙只能被一个人拿. 求全部的人拿到钥匙并且走到门的最短时间. 题解: 显然没有交叉的情况,因为如果交叉的话可能不是最优解. 然后考虑dp[i][j]表示第i个人拿了第j把钥匙,然后 dp[i][j]=max(val(i,j),min(dp[i-1][i-1~j]))   val(i,j)表示第i个人拿

Codeforces Round #424 (Div. 2) C. Jury Marks(乱搞)

题目链接:Codeforces Round #424 (Div. 2) C. Jury Marks 题意: 给你一个有n个数序列,现在让你确定一个x,使得x通过挨着加这个序列的每一个数能出现所有给出的k个数. 问合法的x有多少个.题目保证这k个数完全不同. 题解: 显然,要将这n个数求一下前缀和,并且排一下序,这样,能出现的数就可以表示为x+a,x+b,x+c了. 这里 x+a,x+b,x+c是递增的.这里我把这个序列叫做A序列 然后对于给出的k个数,我们也排一下序,这里我把它叫做B序列,如果我

[Codeforces] Round #352 (Div. 2)

人生不止眼前的狗血,还有远方的狗带 A题B题一如既往的丝帛题 A题题意:询问按照12345678910111213...的顺序排列下去第n(n<=10^3)个数是多少 题解:打表,输出 1 #include<bits/stdc++.h> 2 using namespace std; 3 int dig[10],A[1005]; 4 int main(){ 5 int aa=0; 6 for(int i=1;;i++){ 7 int x=i,dd=0; 8 while(x)dig[++dd

Codeforces Round #273 (Div. 2)

Codeforces Round #273 (Div. 2) 题目链接 A:签到,仅仅要推断总和是不是5的倍数就可以,注意推断0的情况 B:最大值的情况是每一个集合先放1个,剩下都丢到一个集合去,最小值是尽量平均去分 C:假如3种球从小到大是a, b, c,那么假设(a + b) 2 <= c这个比較明显答案就是a + b了.由于c肯定要剩余了,假设(a + b)2 > c的话,就肯定能构造出最优的(a + b + c) / 3,由于肯定能够先拿a和b去消除c,而且控制a和b成2倍关系或者消除

Codeforces Round #339 (Div. 2) B. Gena&#39;s Code

B. Gena's Code It's the year 4527 and the tanks game that we all know and love still exists. There also exists Great Gena's code, written in 2016. The problem this code solves is: given the number of tanks that go into the battle from each country, f